/*
 * int-surprises/uint-surprises.c --
 *
 * Surprises with unsigned integers (not only in C).
 */

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

static void
wraps()
{
    uint8_t n;

    n = UINT8_MAX;
    printf("%d\n", ++n);

    n = 42;
    n += UINT8_MAX;
    printf("%d\n", ++n);

    n -= UINT8_MAX;
    printf("%d\n", --n);
}

static void
dots(int n)
{
    uint8_t i;

    for (i = 0; i < n; i++) {
        putchar('.');
    }
    putchar('\n');
}

int
main(int argc, char *argv[])
{
    int i;

    wraps();
    for (i = 1; i < argc; i++) {
        dots(atoi(argv[i]));
    }
    return 0;
}
